unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, VirtualTrees, TBXStatusBars, ExtCtrls, TBXDkPanels, Math,
  SpTBXDkPanels, DateUtils, ImgList, AppEvnts, ShellAPI, Menus, TB2Item,
  TBX, SpTBXItem, uShutDownTimeCycle, IniFiles;

type
  TForm1 = class(TForm)
    VirtualTree: TVirtualStringTree;
    Timer: TTimer;
    TBXStatusBar: TTBXStatusBar;
    TBXAlignmentPanel1: TTBXAlignmentPanel;
    SpTBXButton1: TSpTBXButton;
    SpTBXButton2: TSpTBXButton;
    SpTBXButton3: TSpTBXButton;
    ImageList: TImageList;
    ApplicationEvents: TApplicationEvents;
    PopupMenu: TPopupMenu;
    Exit1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    TBXPopupMenu1: TTBXPopupMenu;
    SpTBXItem1: TSpTBXItem;
    SpTBXItem2: TSpTBXItem;
    SpTBXItem3: TSpTBXItem;
    SpTBXItem4: TSpTBXItem;
    SpTBXSeparatorItem1: TSpTBXSeparatorItem;
    SpTBXSeparatorItem2: TSpTBXSeparatorItem;
    SpTBXSeparatorItem3: TSpTBXSeparatorItem;
    SpTBXItem5: TSpTBXItem;
    SpTBXButton4: TSpTBXButton;
    SpTBXItem6: TSpTBXItem;
    SpTBXSeparatorItem4: TSpTBXSeparatorItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpTBXButton1Click(Sender: TObject);
    procedure VirtualTreeGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure TimerTimer(Sender: TObject);
    procedure VirtualTreeGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure SpTBXButton3Click(Sender: TObject);
    procedure VirtualTreeDblClick(Sender: TObject);
    procedure SpTBXButton2Click(Sender: TObject);
    procedure ApplicationEventsMinimize(Sender: TObject);
    procedure ApplicationEventsRestore(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SpTBXItem2Click(Sender: TObject);
    procedure SpTBXItem1Click(Sender: TObject);
    procedure SpTBXItem4Click(Sender: TObject);
    procedure SpTBXItem3Click(Sender: TObject);
    procedure TBXPopupMenu1Popup(Sender: TObject);
    procedure SpTBXButton4Click(Sender: TObject);
    procedure SpTBXItem6Click(Sender: TObject);
    procedure VirtualTreeBeforeItemErase(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; ItemRect: TRect;
      var ItemColor: TColor; var EraseAction: TItemEraseAction);
  private
    { Private 錾 }
    FList: TList;
    FNextIndex: TShutDownTime; //̃ACe

    sshighlight: Boolean;
    sshighlightcolor: TColor;
    ssautodelete: Boolean;
    ssdownexforce: Boolean;
    ssspeeddown: Boolean;

    NID : TNotifyIconData;
    procedure WMUSER(var Msg : TMsg); message WM_USER + 123;
    procedure GetNextSchedule;
    procedure WinDown(Mode: TShutDownType);
    procedure WinSleep(SleepOrStop: Boolean);
    procedure ReadIni;
  public
    { Public 錾 }
    procedure MainWndForg;
    procedure UpdateList;
    procedure Save;
    procedure Load;
  end;

var
  Form1: TForm1;
  _SetSuspendState: function (Hibernate, ForceCritical, DisableWakeEvent: BOOL): BOOL
  stdcall = nil;
  function LinkAPI(const module, functionname: string): Pointer; forward;

implementation

uses EditItem, varForm, CancelForm, SettingForm;

{$R *.dfm}
{$R WindownListXP.RES}

function SetSuspendState(Hibernate, ForceCritical,
  DisableWakeEvent: Boolean): Boolean;
begin
  if not Assigned(_SetSuspendState) then
    @_SetSuspendState := LinkAPI('POWRPROF.dll', 'SetSuspendState');
  if Assigned(_SetSuspendState) then
    Result := _SetSuspendState(Hibernate, ForceCritical,
      DisableWakeEvent)
  else
    Result := False;
end;

function LinkAPI(const module, functionname: string): Pointer;
var
  hLib: HMODULE;
begin
  hLib := GetModulehandle(PChar(module));
  if hLib = 0 then
    hLib := LoadLibrary(PChar(module));
  if hLib <> 0 then
    Result := getProcAddress(hLib, PChar(functionname))
  else
    Result := nil;
end;

procedure TForm1.WinSleep(SleepOrStop: Boolean);
begin
  SetSuspendState(not SleepOrStop, ssdownexforce, true);
end;

procedure TForm1.ReadIni;
var
  ini: TMemIniFile;
begin
  ini := TMemIniFile.Create(ExtractFilePath(Application.ExeName) + 'Setting.ini');
  try
    sshighlight :=
      ini.ReadBool('Setting','Highlight',false);
    sshighlightcolor :=
      ini.ReadInteger('Setting','HighlightColor',clSkyBlue);
    ssautodelete :=
      ini.ReadBool('Setting','AutoDelete',false);
    ssdownexforce :=
      ini.ReadBool('Setting','EWX_FORCE',false);
    ssspeeddown :=
      ini.ReadBool('Setting','SpeedDown',false);
  finally
    ini.Free;
  end;
end;

procedure TForm1.MainWndForg;
begin
  Application.Restore;
  ShowWindow(Self.Handle,SW_SHOW);
  SetForegroundWindow(self.Handle);
  SetWindowPos(Handle,HWND_TOP,0,0,0,0,SWP_SHOWWINDOW
    or SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TForm1.WMUSER(var Msg: TMsg);
var
  Pos: TPoint;
begin
  case Msg.wParam of
  WM_RBUTTONDOWN:
    begin
      SetForegroundWindow(Handle);
      GetCursorPos(Pos);
      PopupMenu.Popup(Pos.X,Pos.Y);
      PostMessage(Handle, WM_NULL, 0, 0);
    end;
  WM_LBUTTONDOWN:
    begin
      Application.Restore;
      MainWndForg;
    end;
  end;
end;

procedure TForm1.Load;
var
  i,x: integer;
  IT: TShutDownTime;
  List,List2: TStringList;
begin
  List := TStringList.Create;
  List2 := TStringList.Create;
  try
    if FileExists(ExtractFilePath(Application.ExeName)
       + 'ShutDown.DB') = False then
      Exit;

    List.LoadFromFile(ExtractFilePath(Application.ExeName)
       + 'ShutDown.DB');
    for i := 0 to List.Count-1 do
    begin
      List2.Text :=
        StringReplace(List[i],#9,#13#10,[rfReplaceAll]);
        
      IT := TShutDownTime.Create;
      for x := 0 to List2.Count-1 do
      begin
        case x of
        0:IT.Name := List2[x];
        1:IT.ShutDownTimeCycle := TShutDownTimeCycle(StrToIntDef(List2[x],0));
        2:IT.ShutDownTime := StrToFloat(List2[x]);
        3:IT.ShutDownTimeCycleWeek :=
          TShutDownTimeCycleWeek(StrToIntDef(List2[x],0));
        4:IT.ShutDownTimeCycleTodayTime := StrToFloat(List2[x]);
        5:IT.Enable := StrToBoolDef(List2[x],true);
        6:IT.Types := TShutDownType(StrToIntDef(List2[x],0));
        end;
      end;
      FList.Add(IT);
    end;
    UpdateList;
  finally
    List2.Free;
    List.Free;
  end;
end;

procedure TForm1.Save;
var
  i: integer;
  IT: TShutDownTime;
  List: TStringList;
begin
  List := TStringList.Create;
  try
    for i := 0 to FList.Count-1 do
    begin
      IT := TShutDownTime(FList[i]);
      List.Add(IT.Name+#9+IntToStr(Integer(IT.ShutDownTimeCycle)) + #9 +
        FloatToStr(IT.ShutDownTime) + #9 +
        IntToStr(Integer(IT.ShutDownTimeCycleWeek)) + #9 +
        FloatToStr(IT.ShutDownTimeCycleTodayTime) + #9 +
        BoolToStr(It.Enable) + #9 +
        IntToStr(Integer(IT.Types)));
    end;
    List.SaveToFile(ExtractFilePath(Application.ExeName) + 'ShutDown.DB');
    List.SaveToFile(ExtractFilePath(Application.ExeName) + 'ShutDown.~DB');
  finally
    List.Free;
  end;
end;

procedure TForm1.WinDown(Mode: TShutDownType);
var
  TokenPriv: TTokenPrivileges;
  TokenHandle: THandle;
  CP: THandle;
  Flag: Cardinal;
begin
  CP := GetCurrentProcess;
  if OpenProcessToken(
    CP, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, TokenHandle) then
  begin
    if LookupPrivilegeValue(Nil,'SeShutdownPrivilege',
      TokenPriv.Privileges[0].LUID) then
    begin
      // ShutdownLɂli[
      TokenPriv.PrivilegeCount := 1;
      TokenPriv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      AdjustTokenPrivileges(TokenHandle, FALSE, TokenPriv, 0,
        TTokenPrivileges(nil^), DWORD(nil^));
      //EWX_SHUTDOWN
      case Mode of
      TSDTShutDown: Flag := EWX_POWEROFF;
      TSDTReboot: Flag := EWX_REBOOT;
      else Flag := EWX_POWEROFF;
      end;

      if ssdownexforce then
        Flag := Flag or EWX_FORCE;

      ExitWindowsEx(Flag,0);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  ND: PVirtualNode;
  id: integer;
begin
  FList := TList.Create;
  Load;

  with NID do begin
    cbSize :=Sizeof(NID);
    hIcon := Application.Icon.Handle;
    Wnd  := Self.Handle;
    uID := 1;
    szTip :='WinDownList';
    uCallbackMessage :=WM_USER + 123;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  end;

  ReadIni;

  //ACRǉ
  Shell_NotifyIcon(NIM_ADD, @NID);

  //ACȅ
  if ssautodelete then
  begin
    ND := VirtualTree.GetLast;
    while ND <> nil do
    begin
      id := VirtualTree.AbsoluteIndex(ND);
      if TShutDownTime(FList[id]).CheckEnable then
      begin
        TObject(FList[id]).Free;
        FList.Delete(id);
      end;
      ND := VirtualTree.GetPrevious(ND);
    end;
    Save;
    UpdateList;
  end;

  GetNextSchedule;
  VirtualTree.Invalidate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  Shell_NotifyIcon(NIM_DELETE, @NID);
  for i := 0 to FList.Count-1 do
  begin
    TObject(FList[i]).Free;
  end;
  FList.Free;
end;

procedure TForm1.SpTBXButton1Click(Sender: TObject);
var
  Form: TForm2;
  Item: TShutDownTime;
begin
  Form := TForm2.Create(Self);
  try
    if Form.ShowModal = mrOk then
    begin
      Item := TShutDownTime.Create;
      Item.Name := Form.ItemName.Text;
      Item.ShutDownTime := Form.shutdownTime.DateTime;
      if Form.SSitei.Checked then
        Item.ShutDownTimeCycle := TSDCToday;
      if Form.SMainiti.Checked then
        Item.ShutDownTimeCycle := TSDCEveryday;
      if Form.SMaisyuu.Checked then
        Item.ShutDownTimeCycle := TSDCEveryweek;
      Item.ShutDownTimeCycleTodayTime := Form.SSiteiTime.DateTime;
      Item.ShutDownTimeCycleWeek := TShutDownTimeCycleWeek(
        Form.SSiteiSyuu.ItemIndex);
      if Form.sshutdown.Checked then
        Item.Types := TSDTShutDown;
      if Form.sreboot.Checked then
        Item.Types := TSDTReboot;
      if Form.ssHibernate.Checked then
        Item.Types := TSDTHibernate;
      if Form.ssSuspend.Checked then
        Item.Types := TSDTSuspend;

      FList.Add(Item);
      Save;
      UpdateList;
      GetNextSchedule;
    end;
  finally
    Form.Free;
  end;
end;

function CompareList(Item1, Item2: Pointer): Integer;
begin
  Result := CompareValue(TShutDownTime(Item1).GetNextTime,
    TShutDownTime(Item2).GetNextTime);
end;

procedure TForm1.GetNextSchedule;
  procedure execdown(item: TShutDownTime);
  begin
    if (item.Types = TSDTHibernate) or
      (item.Types = TSDTSuspend) then
    begin
      WinSleep((item.Types = TSDTSuspend));
    end else
    begin
      WinDown(item.Types);
    end;
  end;
var
  tmpList: TList;
  i: integer;
  Form: TForm4;
begin
  //܂Xg̃\[g
  FNextIndex := nil;
  tmpList := TList.Create;
  try
    tmpList.Assign(FList);
    tmpList.Sort(@CompareList);
    TBXStatusBar.SimpleText := '';
    for i := 0 to tmpList.Count-1 do
    begin
      if (TShutDownTime(tmpList[i]).GetNextTime <> -1) and
        (TShutDownTime(tmpList[i]).Enable = true) then
      begin
        //qbg
        TBXStatusBar.SimpleText := '̃Vbg_E^CF'
          + TShutDownTime(tmpList[i]).Name + ' ' +
          TShutDownTime(tmpList[i]).GetNextTimeStr;
        FNextIndex := TShutDownTime(tmpList[i]);
        //0Ȃғ
        if TShutDownTime(tmpList[i]).GetNextTime = 0 then
        begin
          Form := TForm4.Create(Self);
          MainWndForg;
          Timer.Enabled := False;
          try
            if ssspeeddown then
            begin
              execdown(TShutDownTime(tmpList[i]));
            end else
            begin
              if Form.ShowModal = mrOk then
              begin
                execdown(TShutDownTime(tmpList[i]));
              end;
            end;
          finally
            Timer.Enabled := True;
            Form.Free;
          end;
        end;
        Break;
      end;
    end;
  finally
  end;
end;

procedure TForm1.VirtualTreeGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
begin
  case Column of
  0:CellText := TShutDownTime(FList[Node.Index]).Name;
  1:CellText := TShutDownTime(FList[Node.Index]).GetShutDownState;
  2:CellText := TShutDownTime(FList[Node.Index]).GetNextTimeStr;
  3:begin
      case TShutDownTime(FList[Node.Index]).Types of
      TSDTShutDown:CellText := 'Vbg_E';
      TSDTReboot:CellText := 'u[g';
      TSDTHibernate:CellText := 'x~';
      TSDTSuspend:CellText := 'X^oC';
      end;
    end;
  end;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  GetNextSchedule;
  VirtualTree.Invalidate;
end;

procedure TForm1.UpdateList;
begin
  VirtualTree.RootNodeCount := FList.Count;
  VirtualTree.Invalidate;
end;

procedure TForm1.VirtualTreeGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
begin
  if (Kind = ikNormal) or (Kind = ikSelected) then
  begin
    if Column = 0 then
    begin
      if TShutDownTime(
        FList[VirtualTree.AbsoluteIndex(Node)]).Enable then
        ImageIndex := 0
      else
        ImageIndex := 5;
    end;
  end;
end;

procedure TForm1.ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
begin
  SpTBXButton3.Enabled := (VirtualTree.SelectedCount = 1);
  SpTBXButton2.Enabled := (VirtualTree.SelectedCount <> 0);
  SpTBXButton4.Enabled := (VirtualTree.SelectedCount <> 0);
end;

procedure TForm1.SpTBXButton3Click(Sender: TObject);
var
  Form: TForm2;
  Item: TShutDownTime;
begin
  if VirtualTree.SelectedCount = 0 then
    Exit;

  Form := TForm2.Create(Self);
  try
    Item := TShutDownTime(
      FList[VirtualTree.AbsoluteIndex(VirtualTree.GetFirstSelected)]);
    Form.ItemName.Text := Item.Name;
    Form.shutdownTime.DateTime := Item.ShutDownTime;
    if Item.ShutDownTimeCycle = TSDCToday then
      Form.SSitei.Checked := True;
    if Item.ShutDownTimeCycle = TSDCEveryday then
      Form.SMainiti.Checked := True;
    if Item.ShutDownTimeCycle = TSDCEveryweek then
      Form.SMaisyuu.Checked := True;
    case Item.Types of
    TSDTShutDown:Form.sshutdown.Checked := True;
    TSDTReboot:Form.sreboot.Checked := True;
    TSDTHibernate:Form.ssHibernate.Checked := True;
    TSDTSuspend:Form.ssSuspend.Checked := True;
    end;

    Form.SSiteiTime.DateTime := Item.ShutDownTimeCycleTodayTime;
    Form.SSiteiSyuu.ItemIndex := Integer(
      Item.ShutDownTimeCycleWeek);
      
    if Form.ShowModal = mrOk then
    begin
      Item.Name := Form.ItemName.Text;
      Item.ShutDownTime := Form.shutdownTime.DateTime;
      if Form.SSitei.Checked then
        Item.ShutDownTimeCycle := TSDCToday;
      if Form.SMainiti.Checked then
        Item.ShutDownTimeCycle := TSDCEveryday;
      if Form.SMaisyuu.Checked then
        Item.ShutDownTimeCycle := TSDCEveryweek;
      Item.ShutDownTimeCycleTodayTime := Form.SSiteiTime.DateTime;
      Item.ShutDownTimeCycleWeek := TShutDownTimeCycleWeek(
        Form.SSiteiSyuu.ItemIndex);
      if Form.sshutdown.Checked then
        Item.Types := TSDTShutDown;
      if Form.sreboot.Checked then
        Item.Types := TSDTReboot;
      if Form.ssHibernate.Checked then
        Item.Types := TSDTHibernate;
      if Form.ssSuspend.Checked then
        Item.Types := TSDTSuspend;
      Save;
      UpdateList;
      GetNextSchedule;
    end;
  finally
    Form.Free;
  end;
end;

procedure TForm1.VirtualTreeDblClick(Sender: TObject);
begin
  SpTBXButton3Click(nil);
end;

procedure TForm1.SpTBXButton2Click(Sender: TObject);
var
  ND: PVirtualNode;
  id: integer;
begin
  if VirtualTree.SelectedCount = 0 then
    Exit;

  Beep;
  if MessageDlg('I͈͂폜܂B'+#13#10+
    '폜Ɏŏ㏑ۑ̂Ōɖ߂܂B'+#13#10+
    'ꉞobNAbvt@CĂ̂'+#13#10+
    'Ԉꍇ͂ŕĂB'+#13#10+
    '낵łH'+#13#10,
    mtWarning,[mbYes,mbNo],0) = mrYes then
  begin
    ND := VirtualTree.GetLast;
    while ND <> nil do
    begin
      if VirtualTree.Selected[ND] then
      begin
        id := VirtualTree.AbsoluteIndex(ND);
        TObject(FList[id]).Free;
        FList.Delete(id);
      end;
      ND := VirtualTree.GetPrevious(ND);
    end;
    Save;
    UpdateList;
    GetNextSchedule;
  end;
end;

procedure TForm1.ApplicationEventsMinimize(Sender: TObject);
begin
  ShowWindow(Application.Handle,SW_HIDE);
end;

procedure TForm1.ApplicationEventsRestore(Sender: TObject);
begin
  ShowWindow(Application.Handle,SW_SHOW);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  Application.Restore;
  MainWndForg;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SpTBXItem2Click(Sender: TObject);
var
  Form: TForm3;
begin
  Form := TForm3.Create(Self);
  try
    Form.ShowModal;
  finally
    Form.Free;
  end;
end;

procedure TForm1.SpTBXItem1Click(Sender: TObject);
begin
  SpTBXButton1Click(nil);
end;

procedure TForm1.SpTBXItem4Click(Sender: TObject);
begin
  SpTBXButton3Click(nil);
end;

procedure TForm1.SpTBXItem3Click(Sender: TObject);
begin
  SpTBXButton2Click(nil);
end;

procedure TForm1.TBXPopupMenu1Popup(Sender: TObject);
begin
  SpTBXItem4.Enabled := (VirtualTree.SelectedCount = 1);
  SpTBXItem3.Enabled := (VirtualTree.SelectedCount <> 0);
  SpTBXItem5.Enabled := (VirtualTree.SelectedCount <> 0);
end;

procedure TForm1.SpTBXButton4Click(Sender: TObject);
var
  ND: PVirtualNode;
  id: integer;
begin
  if VirtualTree.SelectedCount = 0 then
    Exit;

  ND := VirtualTree.GetLast;
  while ND <> nil do
  begin
    if VirtualTree.Selected[ND] then
    begin
      id := VirtualTree.AbsoluteIndex(ND);
      TShutDownTime(FList[id]).Enable := not TShutDownTime(FList[id]).Enable;
    end;
    ND := VirtualTree.GetPrevious(ND);
  end;
  Save;
  UpdateList;
  GetNextSchedule;
  VirtualTree.Invalidate;
end;

procedure TForm1.SpTBXItem6Click(Sender: TObject);
var
  Form: TFormSetting;
begin
  Form := TFormSetting.Create(self);
  try
    if Form.ShowModal = mrok then
    begin
      ReadIni;
      VirtualTree.Invalidate;
    end;
  finally
    Form.Free;
  end;
end;

procedure TForm1.VirtualTreeBeforeItemErase(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; ItemRect: TRect;
  var ItemColor: TColor; var EraseAction: TItemEraseAction);
begin
  if sshighlight then
  begin
    if TShutDownTime(FList[Sender.AbsoluteIndex(Node)]) = FNextIndex then
      ItemColor := sshighlightcolor else
      ItemColor := TVirtualStringTree(Sender).Color;
    EraseAction := eaColor;
  end;
end;

end.
