unit uShutDownTimeCycle;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Dialogs, Math, DateUtils;

type
  TShutDownTimeCycle = (TSDCToday,TSDCEveryday,TSDCEveryweek);
  TShutDownTimeCycleWeek = (TSDTCWGetu,TSDTCWKa,TSDTCWSui,TSDTCWMoku,
    TSDTCWKin,TSDTCWDo,TSDTCWNiti);
  TShutDownType = (TSDTShutDown,TSDTReboot,TSDTHibernate,TSDTSuspend);
  TShutDownTime = class
  private
    FName: String;
    FShutDownTCycle: TShutDownTimeCycle;
    FShutDownTime: TDateTime;
    FShutDownTimeCycleWeek: TShutDownTimeCycleWeek;
    FShutDownTimeCycleTodayTime: TDateTime;
    FTypes: TShutDownType;
    FEnable: Boolean; //L
    function MakeND: TDateTime; //GetNext...ŎgDateTime
  public
    function GetNextTimeStr: String; //Ƃǂꂭ炢邩Ԃ
    function GetNextTime: Integer; //Ɖb
    function GetShutDownState: String;
    function CheckEnable: Boolean; //TrueŖ
    property Name: String read FName write FName;
    property ShutDownTime: TDateTime read FShutDownTime write FShutDownTime;
    property ShutDownTimeCycle: TShutDownTimeCycle
      read FShutDownTCycle write FShutDownTCycle;
    property ShutDownTimeCycleWeek: TShutDownTimeCycleWeek
      read FShutDownTimeCycleWeek write FShutDownTimeCycleWeek;
    property ShutDownTimeCycleTodayTime: TDateTime
      read FShutDownTimeCycleTodayTime write FShutDownTimeCycleTodayTime;
    property Enable: Boolean read FEnable write FEnable;
    property Types: TShutDownType read FTypes write FTypes;
    constructor Create;
  end;

implementation

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//
//                          TShutDownTimeNX
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

  constructor TShutDownTime.Create;
  begin
    FEnable := True;
    FTypes := TSDTShutDown;
  end;

  function TShutDownTime.GetShutDownState: String;
  begin
    case ShutDownTimeCycle of
    TSDCToday:Result := DateTimeToStr(Self.ShutDownTimeCycleTodayTime) + ' ';
    TSDCEveryday:Result := ' ';
    TSDCEveryweek:
      begin
        Result := 'T';
        case ShutDownTimeCycleWeek of
        TSDTCWGetu: Result := Result + 'j ';
        TSDTCWKa: Result := Result + 'Ηj ';
        TSDTCWSui: Result := Result + 'j ';
        TSDTCWMoku: Result := Result + 'ؗj ';
        TSDTCWKin: Result := Result + 'j ';
        TSDTCWDo: Result := Result + 'yj ';
        TSDTCWNiti: Result := Result + 'j ';
        end;
      end;
    end;

    Result := Result + FormatDateTime('hh""nn""',ShutDownTime);
  end;

  function TShutDownTime.GetNextTime: Integer;
  var
    ND: TDateTime;
  begin
    Result := -1;
    ND := MakeND;
    if ND = -1 then
      Exit;
    Result := SecondsBetween(ND,NOW);
  end;

  function TShutDownTime.MakeND: TDateTime;
  var
    SetWeek: Integer;
    i,D: integer;
  begin
    Result := -1;
    case ShutDownTimeCycle of
    TSDCToday:
      begin
        Result := EncodeDateTime(YearOf(FShutDownTimeCycleTodayTime),
                MonthOf(FShutDownTimeCycleTodayTime),
                DayOf(FShutDownTimeCycleTodayTime),
                HourOf(FShutDownTime),
                MinuteOf(FShutDownTime),
                SecondOf(FShutDownTime),
                0);
        if Now >= Result then
          Result := -1;
        //߂tȂ疳ɂ
      end;
    TSDCEveryday:
      begin
        Result := EncodeDateTime(YearOf(Now),
                MonthOf(Now),
                DayOf(Now),
                HourOf(FShutDownTime),
                MinuteOf(FShutDownTime),
                SecondOf(FShutDownTime),
                0);
        if Result <= NOW then
        begin
          Result := IncDay(Result); //͎Ԃ߂ĂȂ疾ĂƂɂ
        end;
      end;
    TSDCEveryweek:
      begin
        Result := EncodeDateTime(YearOf(Now),
                MonthOf(Now),
                DayOf(Now),
                HourOf(FShutDownTime),
                MinuteOf(FShutDownTime),
                SecondOf(FShutDownTime),
                0);
        SetWeek := Integer(FShutDownTimeCycleWeek) + 1;

        //SۂǋCɂȂ
        D := 1;
        if FormatDateTime('ddd',Result) = ShortDayNames[2] then    
          D := 1;                                                  
        if FormatDateTime('ddd',Result) = ShortDayNames[3] then
          D := 2;                                                  
        if FormatDateTime('ddd',Result) = ShortDayNames[4] then    
          D := 3;
        if FormatDateTime('ddd',Result) = ShortDayNames[5] then
          D := 4;
        if FormatDateTime('ddd',Result) = ShortDayNames[6] then
          D := 5;
        if FormatDateTime('ddd',Result) = ShortDayNames[7] then
          D := 6;
        if FormatDateTime('ddd',Result) = ShortDayNames[1] then
          D := 7;
        if SetWeek < D then
        begin
          //ŵقi܂ŝŗTɑj
          for i := 0 to  (6-D){j} + SetWeek do
            Result := IncDay(Result);
        end else
        begin

          //ŵقł(܂܂T͎sĂȂj
          if SetWeek > D then
            for i := 0 to SetWeek - D - 1 do
              Result := IncDay(Result);
        end;

        if D = SetWeek then
        begin
          //Ԃ߂ĂȂTi߂
          if Result <= NOW then
            Result := IncWeek(Result);
        end;
      end;
    end;
  end;

  function TShutDownTime.CheckEnable: Boolean;
  var
    ND: TDateTime;
  begin
    Result := True; //
    ND := MakeND;
    if ND = -1 then
      Exit;
    Result := false; //L
  end;

  function TShutDownTime.GetNextTimeStr: String;
  var
    ND: TDateTime;
  begin
    Result := 'tiɂ̓߂Ă܂j';
    ND := MakeND;
    if ND = -1 then
      Exit;
    Result := IntToStr(DaysBetween(NOW,ND)) + '' +
      IntToStr(HoursBetween(NOW,ND) mod 24) + '' +
      IntToStr(MinutesBetween(NOW,ND) mod 60) + '' +
      IntToStr(SecondsBetween(NOW,ND) mod 60) + 'b';
  end;

///////////////////////////////////////////////////////////////////////////////



end.
